
TYPE t_comArray RECORD
    celNo SMALLINT,
    celCom STRING 
END RECORD 
DEFINE ma_comArray DYNAMIC ARRAY OF t_comArray

MAIN
    CALL populate_it()
    CALL showMe()
END MAIN


PRIVATE FUNCTION Populate_it()
    DEFINE i SMALLINT
    DEFINE l_sAux STRING 

    CALL ma_comArray.clear()
    FOR i = 1 TO 10
        LET ma_comArray[i].celNo = i USING "&&"
        LET l_sAux = "This is cell no ", i USING "&&", " ", IIF(i MOD 2, "Even", "Odd")
        LET ma_comArray[i].celCom = l_sAux            
    END FOR 
END FUNCTION 

PRIVATE FUNCTION ShowMe()
    DEFINE l_form ui.Form
    DEFINE l_oCellNode om.domNode
    
    LET l_oCellNode = NULL
    
    OPEN WINDOW w_comArray WITH FORM "comArray"
    CLOSE WINDOW SCREEN

    DISPLAY ARRAY ma_comArray TO s_comArray.*
        BEFORE DISPLAY            
            # get the Cell Node
            IF (l_form := dialog.getForm()) IS NOT NULL THEN 
                LET l_oCellNode = getCellNode("formonly.celno", l_form.getNode())
            END IF 
            
        BEFORE ROW 
            # change Comment
            IF l_oCellNode IS NOT NULL THEN 
                CALL l_oCellNode.setAttribute("comment", ma_comArray[dialog.getCurrentRow("s_comarray")].celCom)
            END IF 
            
            
        ON ACTION CLOSE
            EXIT DISPLAY 
    END DISPLAY 
END FUNCTION


PRIVATE FUNCTION getCellNode(p_fieldName, p_oFormNode)
    DEFINE p_fieldName STRING 
    DEFINE p_oFormNode om.domNode
    DEFINE l_oCellNode om.domNode
    DEFINE l_lAux om.NodeList
    DEFINE l_oAux om.DomNode
    DEFINE i,j SMALLINT 

    LET l_oCellNode = NULL
    IF (l_lAux := p_oFormNode.selectByTagName("TableColumn")) IS NOT NULL THEN
        LET i = 0
        LET j = l_lAux.getLength()
        WHILE (i:=(i+1)) <= j AND l_oCellNode IS NULL
            IF ( l_oAux := l_lAux.item(i) ) IS NOT NULL THEN
                IF l_oAux.getAttribute("name") == p_fieldName THEN
                    # found It. Get the Edit Node where's the comment attribute
                    LET l_oCellNode = l_oAux.getFirstChild()
                END IF 
            END IF 
        END WHILE 
    END IF 

    RETURN l_oCellNode
END FUNCTION 
 

